/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2005-2006 Bull S.A.S
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s):
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.sampleCluster2.client;

import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import org.objectweb.sampleCluster2.ejb.MyEjb1Home;
import org.objectweb.sampleCluster2.ejb.MyEjb1;

/**
 * Fat client :
 * - access to a SSB
 * - LB at the remote
 */
public class ClientLBRemote {

    /**
     * Iteration number
     */
    private static final int ITERATION_NB = 50;


    /**
     * Main method
     * @param args arguments of the client
     */
    public static int main(String[] args) {


        String jonasEJBServer = null;
        String ejbTotalCallsCount = null;
        String ejbEntityCreated = null;
        Properties prop = null;

        MyEjb1Home home = ClientUtility.getMyEjb1Home();
        System.out.println("Home retrieved -> " + home);
        MyEjb1 bean = ClientUtility.getMyEjb1Bean(home);
        System.out.println("Bean created -> " + bean);

        for (int i = 1; i < ITERATION_NB + 1; i++) {
            try {

                prop = bean.getInfoProps();
                System.out.println("Bean invoked");

                jonasEJBServer = prop.getProperty("EJB server");
                ejbTotalCallsCount = prop.getProperty("EJB total calls");
                ejbEntityCreated = prop.getProperty("EJB server entity created");
            } catch (Exception e) {
                e.printStackTrace();
                return -1;
            }

            System.out.println("\n");
            System.out.println("Calls=" + i + " - EJB served by jonas=" + jonasEJBServer + " - EJB total calls=" + ejbTotalCallsCount + " - ejbEntityCreated=" + ejbEntityCreated);
            if (0 == (int) i % 10) {
                System.out.println("Sleep 10s");
                try {
                    Thread.sleep(10000);
                } catch (Exception e) {
                    e.printStackTrace();
                    return -1;
                }
            }
        }
        try {
            bean.remove();
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
        System.out.println("Client OK. Exiting.");
        return 0;
    }
}

